{% extends 'base.html.twig' %}

{% form_theme form "form_uikit_layout.html.twig" %}

{% block title %}New Account{% endblock %}

{% block stylesheets %}
    {{ parent() }}
    <style>
        .effect1 {
            text-align: left;
            display: inline-block;
        }

        .effect1 .letter {
            /*display: inline-block;*/
            line-height: 1em;
        }

        .effect1 .letters {
            /*display: inline-block;*/
        }

        .faraway {
            visibility: hidden;
            position: absolute;
            left: -1000px;
            top: -1000px;
        }
    </style>
{% endblock %}

{% block body %}
    <div class="uk-container uk-container-expand uk-text-center">
        <h1 class="uk-heading-large uk-text-center uk-margin-large-top text-wrapper ">
            Welcome, <span class="effect1"><span class="letters">coworker</span></span>
        </h1>
        <p class="uk-text-center uk-text-lead">Please fill in the following values:</p>

        {{ form_start(form, {attr: {class: "uk-form-horizontal uk-width-2-3 uk-margin-large-top uk-margin-auto"}}) }}
        {{ form_rest(form) }}
        {{ form_end(form) }}
    </div>
{% endblock %}

{% block javascripts %}
    {{ parent() }}
    <script src="https://cdn.jsdelivr.net/npm/animejs@3.0.1/lib/anime.min.js"></script>
    <script
            src="https://code.jquery.com/jquery-3.4.1.min.js"
            integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
            crossorigin="anonymous"></script>
    <script>
        const values = ['coworker', 'teammate', 'friend'];
        let i = 0; // The current value

        window.onload = async function () {
            while (true) {
                const $letters = $('.effect1 .letters');

                $letters.text(values[i]);
                $('.effect1').css('opacity', 1); // The animation sets the opacity to 0, let's reset that

                // Calculate the width of the box
                const $hiddenHelper = $('<span/>').addClass('effect1 letters faraway uk-heading-large').appendTo($('.invisibles')).text(values[i]);
                const newWidth = $hiddenHelper.width();
                $hiddenHelper.remove();

                i = (i + 1) % values.length; // Increase i

                // Wrap every letter in a span
                $letters.each(function () {
                    $(this).html($(this).text().replace(/./g, "<span class='letter'>$&</span>"));
                });

                let wait = new Promise(function (resolve, reject) {
                    anime.timeline({loop: false})
                        .add({
                            targets: '.effect1',
                            width: newWidth,
                            easing: "easeOutExpo",
                            duration: 700,
                            delay: 100
                        }).add({
                        targets: '.effect1 .letter',
                        opacity: [0, 1],
                        easing: "easeOutExpo",
                        duration: 600,
                        offset: '-=775',
                        delay: function (el, i) {
                            return 34 * (i + 1)
                        }
                    }).add({
                        targets: '.effect1',
                        opacity: 0,
                        duration: 1000,
                        easing: "easeOutExpo",
                        delay: 1000,
                        complete: function () {
                            resolve(0);
                        }
                    });
                });

                await wait;
            }
        }
    </script>
{% endblock %}
